//
// HistoryTransactional.swift
//
// Generated by openapi-generator
// https://openapi-generator.tech
//

import Foundation
#if canImport(AnyCodable)
import AnyCodable
#endif

public struct HistoryTransactional: Codable, JSONEncodable, Hashable {

    public var id: Int?
    public var changedByMemberKeyNumeric: Double?
    public var fieldKeyNumeric: Double?
    public var historyTransactionalKeyNumeric: Double?
    public var resourceRecordKeyNumeric: Double?
    public var changedByMemberID: String?
    public var changedByMemberKey: String?
    public var className: String?
    public var fieldKey: String?
    public var fieldName: String?
    public var historyTransactionalKey: String?
    public var newValue: String?
    public var originatingSystemHistoryKey: String?
    public var originatingSystemID: Double?
    public var originatingSystemName: String?
    public var previousValue: String?
    public var resourceName: String?
    public var resourceRecordID: String?
    public var resourceRecordKey: String?
    public var sourceSystemHistoryKey: String?
    public var sourceSystemID: Double?
    public var sourceSystemName: String?
    public var changeType: String?
    public var modificationTimestamp: Date?
    public var changedByMember: Member?
    public var originatingSystem: OUID?
    public var sourceSystem: OUID?

    public init(id: Int? = nil, changedByMemberKeyNumeric: Double? = nil, fieldKeyNumeric: Double? = nil, historyTransactionalKeyNumeric: Double? = nil, resourceRecordKeyNumeric: Double? = nil, changedByMemberID: String? = nil, changedByMemberKey: String? = nil, className: String? = nil, fieldKey: String? = nil, fieldName: String? = nil, historyTransactionalKey: String? = nil, newValue: String? = nil, originatingSystemHistoryKey: String? = nil, originatingSystemID: Double? = nil, originatingSystemName: String? = nil, previousValue: String? = nil, resourceName: String? = nil, resourceRecordID: String? = nil, resourceRecordKey: String? = nil, sourceSystemHistoryKey: String? = nil, sourceSystemID: Double? = nil, sourceSystemName: String? = nil, changeType: String? = nil, modificationTimestamp: Date? = nil, changedByMember: Member? = nil, originatingSystem: OUID? = nil, sourceSystem: OUID? = nil) {
        self.id = id
        self.changedByMemberKeyNumeric = changedByMemberKeyNumeric
        self.fieldKeyNumeric = fieldKeyNumeric
        self.historyTransactionalKeyNumeric = historyTransactionalKeyNumeric
        self.resourceRecordKeyNumeric = resourceRecordKeyNumeric
        self.changedByMemberID = changedByMemberID
        self.changedByMemberKey = changedByMemberKey
        self.className = className
        self.fieldKey = fieldKey
        self.fieldName = fieldName
        self.historyTransactionalKey = historyTransactionalKey
        self.newValue = newValue
        self.originatingSystemHistoryKey = originatingSystemHistoryKey
        self.originatingSystemID = originatingSystemID
        self.originatingSystemName = originatingSystemName
        self.previousValue = previousValue
        self.resourceName = resourceName
        self.resourceRecordID = resourceRecordID
        self.resourceRecordKey = resourceRecordKey
        self.sourceSystemHistoryKey = sourceSystemHistoryKey
        self.sourceSystemID = sourceSystemID
        self.sourceSystemName = sourceSystemName
        self.changeType = changeType
        self.modificationTimestamp = modificationTimestamp
        self.changedByMember = changedByMember
        self.originatingSystem = originatingSystem
        self.sourceSystem = sourceSystem
    }

    public enum CodingKeys: String, CodingKey, CaseIterable {
        case id
        case changedByMemberKeyNumeric = "ChangedByMemberKeyNumeric"
        case fieldKeyNumeric = "FieldKeyNumeric"
        case historyTransactionalKeyNumeric = "HistoryTransactionalKeyNumeric"
        case resourceRecordKeyNumeric = "ResourceRecordKeyNumeric"
        case changedByMemberID = "ChangedByMemberID"
        case changedByMemberKey = "ChangedByMemberKey"
        case className = "ClassName"
        case fieldKey = "FieldKey"
        case fieldName = "FieldName"
        case historyTransactionalKey = "HistoryTransactionalKey"
        case newValue = "NewValue"
        case originatingSystemHistoryKey = "OriginatingSystemHistoryKey"
        case originatingSystemID = "OriginatingSystemID"
        case originatingSystemName = "OriginatingSystemName"
        case previousValue = "PreviousValue"
        case resourceName = "ResourceName"
        case resourceRecordID = "ResourceRecordID"
        case resourceRecordKey = "ResourceRecordKey"
        case sourceSystemHistoryKey = "SourceSystemHistoryKey"
        case sourceSystemID = "SourceSystemID"
        case sourceSystemName = "SourceSystemName"
        case changeType = "ChangeType"
        case modificationTimestamp = "ModificationTimestamp"
        case changedByMember = "ChangedByMember"
        case originatingSystem = "OriginatingSystem"
        case sourceSystem = "SourceSystem"
    }

    // Encodable protocol methods

    public func encode(to encoder: Encoder) throws {
        var container = encoder.container(keyedBy: CodingKeys.self)
        try container.encodeIfPresent(id, forKey: .id)
        try container.encodeIfPresent(changedByMemberKeyNumeric, forKey: .changedByMemberKeyNumeric)
        try container.encodeIfPresent(fieldKeyNumeric, forKey: .fieldKeyNumeric)
        try container.encodeIfPresent(historyTransactionalKeyNumeric, forKey: .historyTransactionalKeyNumeric)
        try container.encodeIfPresent(resourceRecordKeyNumeric, forKey: .resourceRecordKeyNumeric)
        try container.encodeIfPresent(changedByMemberID, forKey: .changedByMemberID)
        try container.encodeIfPresent(changedByMemberKey, forKey: .changedByMemberKey)
        try container.encodeIfPresent(className, forKey: .className)
        try container.encodeIfPresent(fieldKey, forKey: .fieldKey)
        try container.encodeIfPresent(fieldName, forKey: .fieldName)
        try container.encodeIfPresent(historyTransactionalKey, forKey: .historyTransactionalKey)
        try container.encodeIfPresent(newValue, forKey: .newValue)
        try container.encodeIfPresent(originatingSystemHistoryKey, forKey: .originatingSystemHistoryKey)
        try container.encodeIfPresent(originatingSystemID, forKey: .originatingSystemID)
        try container.encodeIfPresent(originatingSystemName, forKey: .originatingSystemName)
        try container.encodeIfPresent(previousValue, forKey: .previousValue)
        try container.encodeIfPresent(resourceName, forKey: .resourceName)
        try container.encodeIfPresent(resourceRecordID, forKey: .resourceRecordID)
        try container.encodeIfPresent(resourceRecordKey, forKey: .resourceRecordKey)
        try container.encodeIfPresent(sourceSystemHistoryKey, forKey: .sourceSystemHistoryKey)
        try container.encodeIfPresent(sourceSystemID, forKey: .sourceSystemID)
        try container.encodeIfPresent(sourceSystemName, forKey: .sourceSystemName)
        try container.encodeIfPresent(changeType, forKey: .changeType)
        try container.encodeIfPresent(modificationTimestamp, forKey: .modificationTimestamp)
        try container.encodeIfPresent(changedByMember, forKey: .changedByMember)
        try container.encodeIfPresent(originatingSystem, forKey: .originatingSystem)
        try container.encodeIfPresent(sourceSystem, forKey: .sourceSystem)
    }
}

